// ALGOFON
// This runs on a NODEMCU 1.0 ESP 12-E (should work on an Arduino as well)
// Reads out the rotary dial of a phone and plays different generative sound tracks, based on the number which was dialed

#define  SPEAKER 12

//-----------------------------------------------------
uint8_t pattern[128];


int pitches[] = { 0,
                  65  , 73  , 82  , 87  , 98  , 110 , 123,
                  131 , 147 , 165 , 175 , 196 , 220 , 247,
                  262 , 294 , 330 , 349 , 392 , 440 , 494,
                  523 , 587 , 659 , 698 , 784 , 880 , 988
                };// pitches for 28 notes
uint8_t melody[512];

unsigned long rgbOnTime = 0;
unsigned long rgbOffTime = 0;
unsigned long xmasOnTime = 0;
unsigned long xmasOffTime = 0;
unsigned long pinOnTime = 0;
unsigned long pinOffTime = 0;
int rnd = 0;
int pRnd = 0;
uint32_t rNew = 0;

void setup() {
  Serial.begin(115200);
  delay(300);
  Serial.println("HAIHATUS PHONE / 10 algorithmic 8-bit compositions by Niklas Roy / 2023");
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode (16, INPUT); // Connected to pin D8 on NodeMCU with pull-down resistor
  pinMode (SPEAKER, OUTPUT); // SPEAKER
  tone(SPEAKER, 440);
}

boolean pDial = true;
boolean dial = true;
unsigned long dTime = 0;

int dNumber = 0;

void loop() {
  pDial = dial;
  dial = !digitalRead(16);

  if (dNumber > 0) { // sound during dialing
    if (dial) {
      tone(SPEAKER, 110);
    } else {
      //tone(SPEAKER, 440);
      noTone(SPEAKER);
    }
  }
  if (pDial == false && dial == true) { // add up number
    dTime = millis();
    dNumber++;
    noTone(SPEAKER);
  }
  if (millis() > (dTime + 200) && dNumber > 0) { // got a full number
    call(dNumber);
    dNumber = 0;
  }
  delay(10);
}

void call(int number) {
  randomSeed(millis());
  noTone(SPEAKER);
  delay(500);
  Serial.print("DIALED: ");
  Serial.println(number);

  switch (number) {
    case 1: while (1) {morse(random(1000, 10000L));} break; //top
    case 2: drum2(); break; //super
    case 3: playMelody(); break; // ok
    case 4: multiEffect1(); break; //ok
    case 5: melodyPattern(); break; //super
    case 6: while (1) {upDownMelody(random(10000L, 180000L));} break; //ok
    case 7:  while (1) {msFade(180000L);} break;
    case 8: drumSequence(); break;
    case 9:while(1){rndNoise(100, uint32_t(random(2,150)));}break;
    case 10: while(1){theremin(random(100, 30000L));} break;
  }
}
