//---------------------------------------- melody pattern
void melodyPattern() {
  while (1) {
    Serial.print("melodyPattern");
    int dTime = 100;
    int pitch = 110;
    patternCreator();
    for (int i = 0; i < 3; i++) {
      
      int pCount = 0;
      while (pCount < 128) {
        if (pattern[pCount] != 0) {
          pitch = pitches[(pattern[pCount] * (2 + i) + i * 3 % 27) + 1];
          
          tone(SPEAKER, pitch);
          delay(dTime);
          noTone(SPEAKER);
        } else {
          if (pCount % 2 == 0) {
            rndNoise(dTime / 4, uint32_t(random(1, 200)));
            delay(dTime / 4);
            delay(dTime / 2);
          } else {
            delay(dTime);
          }
        }
        pCount ++;
      }
    }
  }
}




//----------------------------------------------- drums2

void drum2() {
  while (1) {
    createMelody();
    int effectDuration = 200;//random(2) * 200 + 2;
    int loops = 4;

    Serial.print("drum2: ");
    for (int l = 0; l < loops; l++) {
      int q1 = uint32_t(random(10, 500));
      int q2 = uint32_t(random(10, 500));
      boolean q3 = random(100) > 50;
      int q4     = uint32_t(random(35, 80));
      int pCount = 0;
      while (pCount < 180) {
        if (pCount % 64 == 0 && random(100) > 50) {
          
        }
        switch ((melody[pCount] + pCount / 8 + pCount % 2) % 8) {
          case 0:  tone(SPEAKER, uint32_t(random(50, 10000))); rndNoise(effectDuration, (((melody[pCount] % 7 * 10) + pCount) % 1000 + 1)); break;
          case 1:   rndNoise(effectDuration / 2, q1); delay(effectDuration / 2); break;
          case 2:  for (uint8_t k = 1; k < 9; k++) {
              rndNoise(effectDuration / 8, 10 * k);
            } break;
          case 3:  rndNoise(effectDuration / 2, 100); tone(SPEAKER, 1000, effectDuration / 4); delay(effectDuration / 2); break;
          case 4:  rndNoise(effectDuration, uint32_t(random(2, 500))); break;
          case 5:   tone(SPEAKER, q4, effectDuration * 2); delay(effectDuration); digitalWrite(SPEAKER, LOW); break;
          case 6:  if (q3) {
              
              for (uint8_t k = 9; k > 1; k--) {
                tone(SPEAKER, 32 + k * (20 + melody[pCount]));
                delay(effectDuration / 8);
              } noTone(SPEAKER);
            } else {
              
              for (uint8_t k = 1; k < 9; k++) {
                tone(SPEAKER, 32 + k * (20 + melody[pCount]));
                delay(effectDuration / 8);
              } noTone(SPEAKER);
            } break;
          case 7: noTone(SPEAKER); digitalWrite(SPEAKER, HIGH); delay(effectDuration / 2); digitalWrite(SPEAKER, LOW); delay(effectDuration / 2); break;
        }
        pCount++;
      }
    }
    noTone(SPEAKER);
    Serial.println();
  }
}

//----------------------------------------------- theremin
void theremin(unsigned long thDuration) {
  
  int thFreq = uint32_t(random(50, 10000));
  int isFreq = thFreq;
  int melodySpeed = uint32_t(random(5, 1000));
  boolean glide = random(100) > 50;
  Serial.print("Theremin: ");
  Serial.print(melodySpeed);
  Serial.print(" duration:");
  Serial.println(thDuration);
  unsigned long thEnd = millis() + thDuration;
  int rndMod1 = random(3) * 4;
  while (millis() < thEnd) {
    

    if (thFreq < 100) {
      thFreq *= 3;
    } else if (thFreq > 3000) {
      thFreq /= 5;
    } else {
      int r = random(4);
      switch (r) {
        case 0: thFreq = thFreq * 2 / 3; break;
        case 1: thFreq = thFreq / 2 * 3; break;
        case 2: thFreq = thFreq * 3 / 4; break;
        case 3: thFreq = thFreq / 4 * 3; break;
      }
    }

    if (isFreq > 2000) {
      
    } else {
      
    }

    int delta = (thFreq - isFreq) / 10;
    for (int i = 0; i < 10; i++) {
      tone(SPEAKER, isFreq);
      isFreq += delta;
      delay(melodySpeed / 10);
    }
    if (glide) {
      delay(melodySpeed / 2);
    }
    isFreq = thFreq;
  }
  delay(melodySpeed * 3);
  noTone(SPEAKER);
}
//------------------------------------ drums

void drumSequence() {
  while (1) {
    patternCreator();
    int effectDuration = 50;
    int loops = 2;
    Serial.print("drumSeq: ");
    for (int l = 0; l < loops; l++) {

      int q1 = uint32_t(random(10, 500));
      int q2 = uint32_t(random(10, 500));
      boolean q3 = random(100) > 50;
      int q4     = uint32_t(random(35, 80));
      int pCount = 0;
      while (pCount < 128) {
        Serial.print(pattern[pCount]);
        switch (pattern[pCount]) {
          case 0:   delay(effectDuration); break;
          case 1:   rndNoise(effectDuration / 2, q1); delay(effectDuration / 2); break;
          case 2:  for (uint8_t k = 1; k < 9; k++) {
              rndNoise(effectDuration / 8, 10 * k);
            } break;
          case 3:  rndNoise(effectDuration / 2, 100); tone(SPEAKER, 1000, effectDuration / 4); delay(effectDuration / 2); break;
          case 4:   rndNoise(effectDuration, q2); break;
          case 5:   tone(SPEAKER, q4, effectDuration * 2); delay(effectDuration); digitalWrite(SPEAKER, LOW); break;
          case 6:  if (q3) {
              for (uint8_t k = 9; k > 1; k--) {
                tone(SPEAKER, 32 + k * 100);
                delay(effectDuration / 8);
              } noTone(SPEAKER);
            } else {
              for (uint8_t k = 1; k < 9; k++) {
                tone(SPEAKER, 32 + k * 100);
                delay(effectDuration / 8);
              } noTone(SPEAKER);
            } break;
        }
        pCount++;
      }
    }
    noTone(SPEAKER);
    delay(effectDuration * 4);
  }
}

void patternCreator() {
  int pCount, pDist, pWait, pRepeat;

  // clear pattern
  while (pCount < 128) {
    pattern[pCount] = 0;
    pCount ++;
  }

  // hihat
  pCount = random(16);
  pDist  = uint32_t(random(2, 8));
  pWait  = uint32_t(random(1, 8)) * 2;
  pRepeat = uint32_t(random(1, 4)) * 2;
  while (pCount < 128) {
    for (uint8_t i = 0; i < pRepeat; i++) {
      pCount += pDist;
      if (pCount < 128) {
        pattern[pCount] = 1;
      }
    }
    pCount += pWait;
  }
  // snare
  pCount = random(16);
  pDist  = uint32_t(random(2, 8)) * 4;
  pWait  = uint32_t(random(1, 8)) * 2;
  pRepeat = uint32_t(random(1, 8)) * 4;
  while (pCount < 128) {
    for (uint8_t i = 0; i < pRepeat; i++) {
      pCount += pDist;
      if (pCount < 128) {
        pattern[pCount] = 2;
      }
    }
    pCount += pWait;
  }
  // hit
  pCount = random(16);
  pDist  = uint32_t(random(2, 8)) * 4;
  pWait  = uint32_t(random(1, 8)) * 2;
  pRepeat = uint32_t(random(1, 16)) * 4;
  while (pCount < 128) {
    for (uint8_t i = 0; i < pRepeat; i++) {
      pCount += pDist;
      if (pCount < 128) {
        pattern[pCount] = 3;
      }
    }
    pCount += pWait;
  }
  // base
  pCount = random(16);
  pDist  = uint32_t(random(2, 8)) * 4;
  pWait  = uint32_t(random(1, 8)) * 2;
  pRepeat = uint32_t(random(1, 4)) * 4;
  while (pCount < 128) {
    for (uint8_t i = 0; i < pRepeat; i++) {
      pCount += pDist;
      if (pCount < 128) {
        pattern[pCount] = 4;
      }
    }
    pCount += pWait;
  }
  // base
  pCount = random(16);
  pDist  = uint32_t(random(2, 8)) * 4;
  pWait  = uint32_t(random(1, 8)) * 2;
  pRepeat = uint32_t(random(1, 4)) * 4;
  while (pCount < 128) {
    for (uint8_t i = 0; i < pRepeat; i++) {
      pCount += pDist;
      if (pCount < 128) {
        pattern[pCount] = 5;
      }
    }
    pCount += pWait;
  }
  // base
  pCount = random(16);
  pDist  = uint32_t(random(2, 8)) * 4;
  pWait  = uint32_t(random(1, 8)) * 2;
  pRepeat = uint32_t(random(1, 4)) * 4;
  while (pCount < 128) {
    for (uint8_t i = 0; i < pRepeat; i++) {
      pCount += pDist;
      if (pCount < 128) {
        pattern[pCount] = 6;
      }
    }
    pCount += pWait;
  }
}

//----------------------------------------------------- multiEffects
void multiEffect2() {
  while (1) {
    for (int i = 0; i < uint32_t(random(5, 50)); i++) {
      crashMix(uint32_t(random(10, 600)));
      extraNoise(uint32_t(random(10, 300)));
      upDownMelody(uint32_t(random(10, 500)));
      morse(uint32_t(random(10, 500)));
    }
  }
}

void multiEffect1() {
  while (1) {
    for (int k = 0; k < uint32_t(random(1, 50)); k++) {
      for (int i = 0; i < 10; i++) {
        noiseBleep(uint32_t(random(10, 300)));
        extraNoise(uint32_t(random(10, 300)));
      }
      morse(random(10, 500));
    }
  }
}
//----------------------------------------------------- beepPause
void beepPause() {
  Serial.println("Beep pause");
  tone(SPEAKER, uint32_t(random(1000, 10000)), 50);
  
  delay(50);
  if (random(100) > 50) {
    
  }
  noTone(SPEAKER);
  int rr = uint32_t(random(1, 20));
  for (int rrr = 0; rrr < rr; rrr++) {
    delay(1000);
  }
}

//----------------------------------------------------- multiFade
void multiFade(unsigned long duration) {
  Serial.print("multiFade:  "); Serial.println(duration);
  unsigned long dEnd = millis() + duration;
  unsigned int td1 = uint32_t(random(1, 100));
  unsigned int cd1 = 1000;
  unsigned int td2 = uint32_t(random(1, 100));
  unsigned int cd2 = 1000;
  unsigned int td3 = uint32_t(random(1, 100));
  unsigned int cd3 = 1000;
  unsigned int td4 = uint32_t(random(1, 100));
  unsigned int cd4 = 1000;
  unsigned int td5 = uint32_t(random(1, 100));
  unsigned int cd5 = 1;
  unsigned int td6 = uint32_t(random(1, 100));
  unsigned int cd6 = 1000;
  while (millis() < dEnd) {
    
    if (cd1 < td1) {
      cd1++;
    }
    if (cd1 > td1) {
      cd1--;
    }
    if (cd1 == td1) {
      td1 = uint32_t(random(1, 3000));
    }
    if (cd2 < td2) {
      cd2++;
    }
    if (cd2 > td2) {
      cd2--;
    }
    if (cd2 == td2) {
      td2 = uint32_t(random(1, 3000));
    }
    if (cd3 < td3) {
      cd3++;
    }
    if (cd3 > td3) {
      cd3--;
    }
    if (cd3 == td3) {
      td3 = uint32_t(random(1, 3000));
    }
    if (cd4 < td4) {
      cd4++;
    }
    if (cd4 > td4) {
      cd4--;
    }
    if (cd4 == td4) {
      td4 = uint32_t(random(1, 3000));
    }
    if (cd5 < td5) {
      cd5++;
    }
    if (cd5 > td5) {
      cd5--;
    }
    if (cd5 == td5) {
      td5 = uint32_t(random(1, 3000));
    }
    if (cd6 < td6) {
      cd6++;
    }
    if (cd6 > td6) {
      cd6--;
    }
    if (cd6 == td6) {
      td6 = uint32_t(random(1, 3000));
    }
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(cd1);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(cd2);
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(cd3);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(cd4);
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(cd5);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(cd6);
  }
  while (cd1 < 5000 && cd2 < 5000) {
    
    cd1++; cd2++; cd3++;
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(cd1);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(cd2);
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(cd3);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(cd4);
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(cd5);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(cd6);
  }
}

//-------------------------------------------------- msFade
void msFade(unsigned long duration) {
  int rndCount = 0;
  Serial.print("msFade:  "); Serial.println(duration);
  unsigned long dEnd = millis() + duration;
  unsigned int targetDelay = uint32_t(random(10, 1000));
  unsigned int currentDelay = 3;
  unsigned int targetDelayOff = uint32_t(random(100, 10000));
  unsigned int currentDelayOff = 3;
  unsigned int freq = 35;
  Serial.print("TargetDelay");
  Serial.println(targetDelay);
  Serial.print("currentDelay");
  Serial.println(currentDelay);
  Serial.print("targetDelayOff");
  Serial.println(targetDelayOff);
  Serial.print("currentDelayOff");
  Serial.println(currentDelayOff);
  while (millis() < dEnd) {

    yield();
    Serial.print("a");
    if (currentDelay < targetDelay) {
      currentDelay++;
    }
    Serial.print("b");
    if (currentDelay > targetDelay) {
      currentDelay--;
    }
    Serial.print("c");
    if (currentDelay == targetDelay) {
      targetDelay = uint32_t(random(5, 5000));
      Serial .print("targetOn:  ");
      Serial.println(targetDelay);
    }
    Serial.print("d");
    if (currentDelayOff < targetDelayOff) {
      currentDelayOff++;
    }
    Serial.print("e");
    if (currentDelayOff > targetDelayOff) {
      currentDelayOff--;
    }
    Serial.print("f");
    yield();
    if (currentDelayOff == targetDelayOff) {
      rndCount++;
      yield();
      Serial.print("g");
      if (random(100) < 20 || rndCount > 5) {
        Serial.print("h");
        rndCount = 0;
        currentDelayOff = uint32_t(random(100, 10000));
        targetDelayOff = uint32_t(random(100, 10000));
        Serial.print("targetOff: ");
        Serial.println(targetDelayOff);
        
      }
      Serial.print("rndTone ");
      tone(SPEAKER, uint32_t(random(1000, 10000)), 100);
      delay(uint32_t(random(10, 200)));
    }

    Serial.print("-cd ");
    Serial.println(currentDelay);
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(currentDelay);
    Serial.print("-co ");
    Serial.println(currentDelayOff);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(currentDelayOff);
  }
  Serial.println("while 2");
  while (currentDelay > 10 || currentDelayOff > 10) {
    if (currentDelay > 10) {
      currentDelay--;
    }
    if (currentDelayOff > 10) {
      currentDelayOff--;
    }
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(currentDelay);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(currentDelayOff);
  }
  noTone(SPEAKER);
}




//------------------------------------------------- upDownMelody
void upDownMelody(unsigned long duration) {
  Serial.print("upDownMelody:  "); Serial.println(duration);
  unsigned long dEnd = millis() + duration;
  unsigned long targetFreq = sqrt(uint32_t(random(3000, 100000L)));
  unsigned long freq = 35;
  while (millis() < dEnd) {
    
    if (freq > targetFreq) {
      
      freq = freq * 3 / 4;
      freq--;
    }
    if (freq < targetFreq) {
      
      freq = freq * 4 / 3;
      freq++;
    }
    if (abs(freq - targetFreq) < 100) {
      targetFreq = sqrt(uint32_t(random(3000, 100000L)));
    }
    tone (SPEAKER, uint32_t(freq));
    delay(random(1, 8) * 100);
  }
  while (freq > 100) {
    freq = freq * 3 / 4;
    tone (SPEAKER, uint32_t(freq));
    delay(random(1, 8) * 100);
  }
  tone (SPEAKER, sqrt(uint32_t(random(3000, 100000L))));
  delay(1000);
  noTone(SPEAKER);
}
//------------------------------------------------------- sound Fade
void soundFade(unsigned long duration, int delayTime) {
  Serial.print("soundFade:  "); Serial.println(duration);
  unsigned long dEnd = millis() + duration;
  unsigned long targetFreq = sqrt(uint32_t(random(1050, 100000L)));
  unsigned long freq = 35;
  while (millis() < dEnd) {
    if (freq > targetFreq) {
      freq --;
    }
    if (freq < targetFreq) {
      freq ++;
    }
    if (abs(freq - targetFreq) < 10) {
      targetFreq = sqrt(uint32_t(random(1500, 100000L)));
    }
    tone (SPEAKER, uint32_t(freq));
    delay(delayTime);
  }
  while (freq > 33) {
    freq--;
    tone (SPEAKER, uint32_t(freq));
    delay(delayTime);
  }
  noTone(SPEAKER);
}
//--------------------------------------------------- morse
void morse(unsigned long morseDuration) {
  if (random(2)) {
    
  }
  Serial.print("morseDuration:  "); Serial.println(morseDuration);
  boolean blinking = random(10) > 4;
  boolean offSound = random(10) > 6;
  int freq = uint32_t(random(40, 5000));
  int mSpeed = uint32_t(random(20, 150));
  unsigned long morseEnd = millis() + morseDuration;
  while (millis() < morseEnd) {
    tone(SPEAKER, freq);
    if (blinking) {
      
    }
    delay(mSpeed * uint32_t(random(1, 3)));
    if (blinking) {
      
    }
    if (offSound) {
      tone(SPEAKER, freq * 2);
    } else {
      noTone(SPEAKER);
    }
    delay(mSpeed);
  }
  delay(mSpeed * 3);
  noTone(SPEAKER);

  if (blinking && random(10) > 5) {
    
  }
}

//--------------------------------------------------- noise
void extraNoise(unsigned long randoDuration) {
  Serial.print("extraNoise:  "); Serial.println(randoDuration);
  unsigned long randoEnd = millis() + randoDuration;
  while (millis() < randoEnd) {
    
    rndNoise(uint32_t(random(1, 100)), random(100));
    digitalWrite(SPEAKER, HIGH);
    delay(random(1, 10));
    digitalWrite(SPEAKER, LOW);
    
  }
}

void noiseBleep(unsigned long randoDuration) {
  Serial.print("noiseBleep:  "); Serial.println(randoDuration);
  unsigned long randoEnd = millis() + randoDuration;
  while (millis() < randoEnd) {
    
    rndNoise(100, random(16000));
    for (int i = 0; i < uint32_t(random(1, 3)); i++) {
      if (random(100) > 90) {
        
        tone(SPEAKER, uint32_t(random(400, 1000)));
        delay(100);
        
        noTone(SPEAKER);
      }
    }
    if (random(100) > 95) {
      
      digitalWrite(SPEAKER, LOW);
      delay(100);
      
      delay(50);
      if (random(100) > 50) {
        
      }
    }
  }
}



void rndNoise(unsigned long randoDuration, int quality) {
  Serial.print("rndNoise:  "); Serial.println(randoDuration);
  unsigned long randoEnd = millis() + randoDuration;
  while (millis() < randoEnd) {
    yield();
    int r = random(10, quality);
    digitalWrite(SPEAKER, HIGH);
    delayMicroseconds(r);
    digitalWrite(SPEAKER, LOW);
    delayMicroseconds(r);
  }
}

//---------------------------------------------------------------- alarms
void alarm2(unsigned long alarmDuration, int delayDuration) {
  Serial.println("Alarm2!");
  unsigned long alarmEnd = millis() + alarmDuration;
  while (millis() < alarmEnd) {
    for (int i = 50; i < 1000; i += 3) {
      
      tone(SPEAKER, i);
      delay(delayDuration);
      tone(SPEAKER, 1000 - i);
      delay(delayDuration);
    }

  }
  noTone(SPEAKER);
}

void alarm(unsigned long alarmDuration, int delayDuration) {
  Serial.println("Alarm!");
  unsigned long alarmEnd = millis() + alarmDuration;
  while (millis() < alarmEnd) {
    for (int i = 50; i < 1000; i += 3) {
      
      tone(SPEAKER, i);
      delay(delayDuration);
    }
    for (int i = 1000; i > 50; i -= 3) {
      
      tone(SPEAKER, i);
      delay(delayDuration);
    }
  }
  noTone(SPEAKER);
}


//-------------------------------------------- phase
void phase(int delayValue, unsigned long phaseDuration) {
  if (random(2)) {
    
  }
  Serial.print("Phase: ");
  Serial.println(phaseDuration);
  unsigned long phaseEnd = millis() + phaseDuration;
  while (millis() < phaseEnd) {
    for (int i = 0; i < 128; i++) {
      
      analogWrite(SPEAKER, i);
      delay(delayValue);
    }
    for (int i = 128; i > 0; i--) {
      
      analogWrite(SPEAKER, i);
      delay(delayValue);
    }
  }
  analogWrite(SPEAKER, 0);
}
//--------------------------------------------- crash mix
unsigned long crashEnd;
void crashMix(unsigned long crashDuration) {
  Serial.print("CrashMix ");
  Serial.println(crashDuration);
  crashEnd = millis() + crashDuration;
  while (millis() < crashEnd) {
    
    switch (random(5)) {
      case 0:
        for (int i = 0; i < random(10000); i++) {
          
          tone(SPEAKER, uint32_t(random(4000, 6000)));
          delay(15);
          if (random(5) == 0)
          {
            
          }
        }
        break;
      case 1:
        for (int i = 0; i < random(10000); i++) {
          
          tone(SPEAKER, uint32_t(random(1000, 7000)));
          delay(20);
        }
        break;
      case 2:
        for (int i = 0; i < random(1000); i++) {
          
          if (i % 16 == 0) {
            
          }
          unsigned int t = random(1024, 7000);
          tone(SPEAKER, sqrt(t));
          delay(100);
        }
        break;
      case 3:
        for (int i = 0; i < random(100); i++) {
          
          rNew = random(4000, 6000);
          tone(SPEAKER, rNew);
          delay(20);
          noTone(SPEAKER);
          delay(200);
          
        }
        break;
      case 4:
        noTone(SPEAKER);
        
        rNew = random(10, 2000);
        delay(rNew);
        break;
    }
    noTone(SPEAKER);
  }
}


//---------------------------------------------------------------------- make melody and play melody

void playStakkato(int duration, boolean blinking) {
  Serial.print("Play Stakkato: ");
  Serial.println(duration);
  rNew = random(2, 4);
  int rndNum = rNew * 8;
  for (int i = 0; i < 512; i++) {
    
    if (pitches[melody[i]] > 0) {
      for (int k = 0; k < 2; k++) {
        tone(SPEAKER, pitches[melody[i]]);
        delay(duration / 8);
        tone(SPEAKER, pitches[melody[i]] * 2);
        delay(duration / 8);
        tone(SPEAKER, pitches[melody[i]]);
        delay(duration / 8);
        tone(SPEAKER, pitches[melody[i]] * 2);
        delay(duration / 8);
      }
    } else {
      noTone(SPEAKER);
      delay(duration / 2);
      
      tone(SPEAKER, 5000, 20);
      delay(duration / 2);

    }
    if (i == 511) {
      delay(duration * 3);
    }
  }
  noTone(SPEAKER);
  Serial.println("end of melody");
}

//-----------------------------------------------------------------------
void playMelody() {
  while (1) {
    createMelody();
    Serial.print("Play Melody: ");
    boolean blinking = false;
    int duration = 200;
    Serial.println(duration);
    rNew = random(2, 4);
    int rndNum = rNew * 8;
    for (int i = 0; i < 512; i++) {
      
      if (i % rndNum == 0) {
        
      }
      if (i > 2 && i < 505 && blinking) {
        if (melody[i] == 0) {
          
        } else if ( melody[i - 1] != melody[i] && melody[i] == melody[i + 1] && melody[i] == melody[i + 2]) {
          
        }
      }
      if (random(10) > 3) {
        if (pitches[melody[i]] > 0) {
          tone(SPEAKER, pitches[melody[i]]);
        } else {
          noTone(SPEAKER);
        }
        delay(duration);
      } else {
        if (pitches[melody[i]] > 0) {
          tone(SPEAKER, pitches[melody[i]]);
        } else {
          noTone(SPEAKER);
        }
        delay(duration / 2);
        if (blinking && melody[i] != 0 && i % 4 == 0) {
          
        }
        if (pitches[melody[i]] > 0) {
          tone(SPEAKER, pitches[melody[i]] * 2);
        } else {
          noTone(SPEAKER);
        }
        delay(duration / 2);
        if (blinking && melody[i] != 0 && i % 4 == 0) {
          
        }
      }

      if (i == 511) {
        delay(duration * 3);
      }
    }
    noTone(SPEAKER);
    Serial.println("end of melody");

  }
}

void createMelody() {
  Serial.println("Create Melody");
  //................................................. 1-32
  // initial note
  melody[1] = random(28) + 1;
  int noteCount = 1;
  for (int i = 0; i < 31; i++) {
    Serial.println(i);
    // make a rest of initial note sequence
    int r = random(8);

    switch (r) {
      case 0: melody[noteCount] = 0; break; // pause
      case 1: if (melody[noteCount - 1] < 14) {
          rNew = random(2, 5);
          melody[noteCount - 1] + rNew;
        } else {
          rNew = random(2, 5);
          melody[noteCount - 1] - rNew;
        } break; // new note
      case 2: if (melody[noteCount - 1] < 14) {// new note
          rNew = random(4, 12);
          melody[noteCount - 1] + rNew;
        } else {
          rNew = random(4, 12);
          melody[noteCount - 1] - rNew;
        } break;
      case 3:// new note
        melody[noteCount] = random(28) + 1;
        while (abs(melody[noteCount] - melody[noteCount - 1]) < 2) {
          melody[noteCount] = random(28) + 1;
        }
        break;
      case 4:// new note
        melody[noteCount] = random(28) + 1;
        while (abs(melody[noteCount] - melody[noteCount - 1]) < 3) {
          melody[noteCount] = random(28) + 1;
        }
        break;
      case 5:// repeat note two before this one
        melody[noteCount] = melody[noteCount - 2];
        break;
      default: melody[noteCount] = melody[noteCount - 1]; // repeat note
    }
    noteCount++;
  }

  Serial.println("Post processing 1");
  while (noteCount < 512) {
    int r = random(5);
    switch (r) {
      case 0:                          // copy first sequence
        for (int i = 0; i < 32; i++) {
          melody[noteCount] = melody[i];
          noteCount++;
        }
        break;
      case 1:                          // copy first sequence lower
        for (int i = 0; i < 32; i++) {
          melody[noteCount] = melody[i] / 2;
          noteCount++;
        }
        break;
      case 2:                          // copy first sequence higher
        for (int i = 0; i < 32; i++) {
          melody[noteCount] = melody[i] / 2;
          noteCount++;
        }
        break;
      case 3:                          // copy first sequence backwards
        for (int i = 31; i >= 0; i--) {
          melody[noteCount] = melody[i] / 2;
          noteCount++;
        }
        break;
      case 4:                          // change one note in initial sequence
        melody[random(32)] = random(28) + 1;
        break;
    }
  }

  // post processing:
  int l, r, pStart, pEnd;
  for (int k = 0; k < 4; k++) {
    r = random(64);
    l = random(16);
    pStart = r * 4;
    pEnd = pStart + l * 4;
    for (int i = pStart; i < pEnd; i++) {
      melody[i] += 4;
      if (melody[i] > 28) {
        melody[i] -= 7;
      }
    }

    r = random(64);
    l = random(16);
    pStart = r * 4;
    pEnd = pStart + l * 4;
    for (int i = pStart; i < pEnd; i++) {
      if (melody[i] > 4) {
        melody[i] -= 3;
      }
    }
  }


  Serial.println("Created Melody:");
  for (int i = 0; i < 256; i++) {
    Serial.print(melody[i]);
    Serial.print(" / ");
    if (i % 4 == 0) {
      Serial.println();
    }
  }
  Serial.println("----");
}


//---------------------------------------------------------------------- melodyMachine makes dudeli sound

unsigned int mmFreq = rNew;
unsigned long mmStart;

void melodyMachine() {
  createMelody();
  unsigned long mmDuration = 200000L;
  int melodySpeed = 200;
  boolean withBlink = false;

  Serial.print("Melody Machine speed: ");
  Serial.print(melodySpeed);
  Serial.print(" duration:");
  Serial.println(mmDuration);
  mmStart = millis();
  int mmCount = 0;
  int rndMod1 = random(3) * 4;
  boolean blinking = random(100) > 50;
  while (millis() < mmStart + mmDuration) {

    mmCount++;
    Serial.println(mmCount);
    if (mmCount % rndMod1 == 0 && blinking) {
      
    }
    if (withBlink)
    if (mmFreq < 100) {
      mmFreq *= 4;
    } else if (mmFreq > 5000) {
      mmFreq /= 4;
    } else {
      int r = random(6);
      switch (r) {
        case 0: mmFreq = mmFreq * 2; break;
        case 1: mmFreq = mmFreq / 2; break;
        case 2: mmFreq = mmFreq * 3 / 2; break;
        case 3: mmFreq = mmFreq * 2 / 3; break;
        case 4: mmFreq = mmFreq / 3 * 2; break;
        case 5: mmFreq = mmFreq / 2 * 3; break;
      }
    }
    tone(SPEAKER, mmFreq);
    delay(melodySpeed);
  }
  delay(melodySpeed * 3);
  noTone(SPEAKER);
  delay(melodySpeed * 4);

}
